<?php
/**
* URLマッパーを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_URLMapperFactory 
{
	/*
	 * URLマッパーを作成
	 */
	public static function create( $url_mapper_name )
	{
		log_info( "system",  "URLマッパー[$url_mapper_name]をロードします。", __FILE__, __LINE__ );

		// Configをロード
		$config = charcoal_ConfigLoader::loadConfig( $url_mapper_name, "url_mapper" );

		// クラス名を取得
		$class_name = $config->getString( "class_name" );

		// URLマッパーのインスタンス生成
		$url_mapper = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIValidatorインタフェースを実装しているか確認
		if ( !($url_mapper instanceof charcoal_IURLMapper) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IURLMapper" );
		}

		log_info( "system",  "URLマッパー[$url_mapper_name]を初期化します。", __FILE__, __LINE__ );

		// URLマッパーを初期化
		$url_mapper->init( $config );

		log_info( "system",  "URLマッパー[$url_mapper_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたURLマッパーを返却
		return $url_mapper;
	}
}
